Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 456447 - udev vol_id probe of passive/unreadable devices causes slow bootup
Summary: udev vol_id probe of passive/unreadable devices causes slow bootup
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: udev
Version: 5.2
Hardware: All
OS: Linux
medium
medium
Target Milestone: rc
: ---
Assignee: Harald Hoyer
QA Contact: qe-baseos-daemons
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2008-07-23 18:24 UTC by John Ruemker
Modified: 2018-11-14 19:29 UTC (History)
8 users (show)

Fixed In Version: udev-095-14.23.el5
Doc Type: Bug Fix
Doc Text:
Previously, the udev helper application 'vol_id' ran several times if a device was unreadable. This caused a massive delay for the bootup process on some machines. With this update, 'vol_id' checks whether a device is readable only once and no longer causes a delay.
Clone Of:
Environment:
Last Closed: 2011-01-13 22:59:25 UTC
Target Upstream Version:


Attachments (Terms of Use)
vol_id patch for udev-095-14.16 (deleted)
2008-07-23 18:25 UTC, John Ruemker
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2011:0073 normal SHIPPED_LIVE udev bug fix and enhancement update 2011-01-12 17:22:05 UTC

Description John Ruemker 2008-07-23 18:24:04 UTC
Description of problem:  udev takes a very long time (~20 minutes) to start on
systems connected to an active/passive SAN with many LUNs.  It appears to be
taking a long time on running vol_id on the passive paths.  Running this command
on one LUN takes between 2-3 minutes 

    [root@prod-xen2 ~]# time /lib/udev/vol_id --export /dev/sdc
     real	1m58.681s
     user	0m0.000s
     sys 	0m0.003s

There is an upstream patch designed to correct this:

   
http://git.kernel.org/?p=linux/hotplug/udev.git;a=commitdiff;h=73ff769c90307e9ef2947c7ba013626fb65c1478
Version-Release number of selected component (if applicable):

Looking at the logs you can see it try over and over

   Jul 23 12:11:31 prod-xen2 kernel: end_request: I/O error, dev sdc, sector 0
   Jul 23 12:11:31 prod-xen2 kernel: Buffer I/O error on device sdc, logical block 0
   Jul 23 12:11:34 prod-xen2 kernel: end_request: I/O error, dev sdc, sector 0
   Jul 23 12:11:37 prod-xen2 kernel: end_request: I/O error, dev sdc, sector 0
   Jul 23 12:11:37 prod-xen2 kernel: printk: 1 messages suppressed.
   Jul 23 12:11:37 prod-xen2 kernel: Buffer I/O error on device sdc, logical block 0

Backporting the above patch to current udev-095-14.16 and running vol_id is much
better:

   [root@prod-xen2 ~]# time ./vol_id --export /dev/sdc
   real    0m3.138s
   user    0m0.000s
   sys     0m0.001s

and only probes the device once:

   Jul 23 14:20:31 prod-xen2 kernel: end_request: I/O error, dev sdc, sector 0
   Jul 23 14:20:31 prod-xen2 kernel: Buffer I/O error on device sdc, logical block 0

Comment 1 John Ruemker 2008-07-23 18:25:47 UTC
Created attachment 312503 [details]
vol_id patch for udev-095-14.16

Comment 4 RHEL Product and Program Management 2009-11-06 19:24:10 UTC
This request was evaluated by Red Hat Product Management for
inclusion, but this component is not scheduled to be updated in
the current Red Hat Enterprise Linux release. If you would like
this request to be reviewed for the next minor release, ask your
support representative to set the next rhel-x.y flag to "?".

Comment 5 John Sobecki 2009-12-11 20:23:52 UTC
Apple computer requested this patch for Oracle Enterprise Linux as they
are seeing these delays with Sun storage using rdac multipathing.

Comment 8 Karel Volný 2010-11-25 13:31:16 UTC
please, what hardware can be used to test with?

Comment 9 Harald Hoyer 2010-11-25 13:38:58 UTC
hmm, you might try with a blank cd-rw in a cdrom

Comment 11 Martin Prpič 2010-12-06 14:13:19 UTC
    Technical note added. If any revisions are required, please edit the "Technical Notes" field
    accordingly. All revisions will be proofread by the Engineering Content Services team.
    
    New Contents:
Previously, the udev helper application 'vol_id' ran several times if a device was unreadable. This caused a massive delay for the bootup process on some machines. With this update, 'vol_id' checks whether a device is readable only once and no longer causes a delay.

Comment 13 errata-xmlrpc 2011-01-13 22:59:25 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2011-0073.html


Note You need to log in before you can comment on or make changes to this bug.